	var oldX = null, oldY = null;
	function dragstart(d) {
		oldX = d.x;
		oldY = d.y;
	};
	function dragend(d) {
		oldX = null;
		oldY = null;
	};
	function dragmove(d) {
		var dx, dy;
		dx = d3.event.x - oldX ;
		dy = d3.event.y - oldY ;
		if(this.__data__.draggable == "true"){
			translateBy(dx, dy, this.parentNode);
			path.attr("d", elbow);
		}
		oldX = d3.event.x;
		oldY = d3.event.y;	
	};
	/*****UTIL*****/
	function topLeft(node){
		return {x: node.__data__.x, y: node.__data__.y }
	};
	function bottomRight(node){
		return {x: node.__data__.x + node.__data__.nodeWidth, y: node.__data__.y + node.__data__.nodeHeight }
	};
	function bottomCenter(node){
		return {x: node.__data__.x + (node.__data__.nodeWidth/2), y: node.__data__.y + node.__data__.nodeHeight }		
	};
	function topCenter(node){
		return {x: node.__data__.x + (node.__data__.nodeWidth/2), y: node.__data__.y }
	};
	function translateBy(dx, dy, node){		
		var newx = d3.event.x,
			newy = d3.event.y,
			thisTopLeft = topLeft(node),
			thisBottomRight = bottomRight(node);
		var parent = $('*[id=' + node.__data__.nodeParentID + ']');
		if(parent.length != 0){
			var parentTopLeft = topLeft(parent[0]),
				parentBottomRight = bottomRight(parent[0]);
			if(node.__data__.nodeShape == "ROCircle"){
				newx = Math.min(Math.max(newx, parent[0].__data__.x + node.__data__.r), parentBottomRight.x - node.__data__.r)
				newy = Math.min(Math.max(newy, parent[0].__data__.y + node.__data__.r ), parentBottomRight.y - node.__data__.r)
			} else {
				newx = Math.min(Math.max(newx, parentTopLeft.x ), parentBottomRight.x - node.__data__.nodeWidth);
				newy = Math.min(Math.max(newy, parentTopLeft.y ), parentBottomRight.y - node.__data__.nodeHeight);
			}
		}
		translateTo(newx, newy, node);
		translateChildrenBy(newx - thisTopLeft.x, newy - thisTopLeft.y, node.id);
	};
	function translateTo(newx, newy, node){
		node.__data__.x = newx;
		node.__data__.y = newy;
		if(node.__data__.nodeShape == "ROCircle"){
			node.setAttribute("cx",node.__data__.x + node.__data__.nodeWidth/2);
			node.setAttribute("cy",node.__data__.y + node.__data__.nodeHeight/2);
		} else {
			node.setAttribute("x",node.__data__.x);
			node.setAttribute("y",node.__data__.y);
		}
	};	
	function translateChildrenBy(dx, dy, nodeParentID){
		$('*[nodeParentID=' + nodeParentID + ']').each(function(index){
			translateTo(this.__data__.x + dx, this.__data__.y + dy, this);
			translateChildrenBy(dx, dy, this.id);
		});
	};
	function getNodesByShape(shape){
		var nodes=dataset.nodes;
		var nodesSize=nodes.length;
		var ret=[];
		for(var i=0;i<nodesSize;i++){
			if(nodes[i].nodeShape==shape) 
			ret.push(nodes[i]);
		}
		return ret;
	};
	function getChildrenNodesByParentIDAndShape(parentID, aShape){
		var nodes=dataset.nodes;
		var nodesSize=nodes.length;
		var ret=[];
		for(var i=0;i<nodesSize;i++){
			if(nodes[i].nodeShape==aShape && nodes[i].nodeParentID == parentID ) 
			ret.push(nodes[i]);
		}
		return ret;
	};
	/*****LINKS*****/
	function elbow(d, i) {
		var start = document.getElementById(d.sourceID);
		var end = document.getElementById(d.targetID);
		var startBottomCenter = bottomCenter(start),
			endTopCenter = topCenter(end);
		return "M" + startBottomCenter.x + "," + startBottomCenter.y
			   + "L" + endTopCenter.x + "," + endTopCenter.y
	};	
